<?php
defined( '_VALID_MOS' ) or die( 'Restricted access' );

$_MAMBOTS->registerFunction( 'onAfterStart', 'botPoints' );

function botPoints(){
	global $mainframe, $database, $mosConfig_uniquemail, $mosConfig_dbprefix;
	
	$option = mosGetParam($_REQUEST, 'option', ''); 
	$task = mosGetParam($_REQUEST, 'task', '');	
	$my = $mainframe->getUser();

	if($option == "com_comprofiler" && $task == "saveregisters"){
		//Registration
		$username = mosGetParam($_REQUEST, 'username', '');
		$email = mosGetParam($_REQUEST, 'email', '');
		
		if($mosConfig_uniquemail){
			$sql = "select count(id) from `#__users` where `username` = '$username' or `email` = '$email'";
		} else {
			$sql = "select count(id) from `#__users` where `username` = '$username'";
		}
		
		$database->setQuery($sql);
		if(!$database->loadResult()){
			$sql = "SHOW TABLE STATUS LIKE '".$mosConfig_dbprefix . "users'";
			$database->setQuery($sql);
			
			$row = $database->loadObjectList();
			$row=$row[0];
			$next_id = $row->Auto_increment;

			//get point equivalent
			$points = getConfPoints("register");
			
			$sql = "insert into `#__karma_tb` values('$next_id', '$points', '$points')";
			$database->setQuery($sql);
			$database->query();
			
			//log points
			logPoints($my->id, $points, "Registration");
		}
	} else if($option == "com_weblinks" && $task == "save"){
		//Weblinks
		if ($my->gid < 1) {
			return 0;
		}
		
		$sql = "select count(id) from `#__weblinks` where `title` = '" . $_POST['title'] . "'";
		$database->setQuery($sql);
		if($database->loadResult()){
			return 0;
		}
		
		//get point equivalent
		$points = getConfPoints("link");
	
		$rows = getUser($my->id);
		$count = count($rows);
		
		$var = 0;
		$total = 0;
		
		if($count){
			$row=$rows[0];
			
			$var = $row->var_karma;
			$total = $row->total_karma;
		}
		
		$var += $points;
		$total += $points;
		
		if($count){
			$sql = "update `#__karma_tb` set `var_karma` = '$var', `total_karma` = '$total' where `user_id` = '$my->id'";
		} else {
			$sql = "insert into `#__karma_tb` values ('$my->id', '$var', '$total')";
		}
		$database->setQuery($sql);
		$database->query();
		
		//log points
		logPoints($my->id, $points, "Submitted Weblink");
		
	} else if($option == "com_fireboard"){
		if ($my->gid < 1) {
			return 0;
		}
		
		$func = mosGetParam($_REQUEST, 'func', '');
		$parentid = mosGetParam($_REQUEST, 'parentid', '');
		$id = mosGetParam($_REQUEST, 'id', '');
		$action = mosGetParam($_REQUEST, 'action', '');
		
		if($func == "post" && $parentid == 0 && $id == 0 && $action == "post"){
			//get point equivalent
			$points = getConfPoints("forum");
			
			$rows = getUser($my->id);
			
			$var = 0;
			$total = 0;
			if(count($rows)){
				$row=$rows[0];
				
				$var = $row->var_karma;
				$total = $row->total_karma;
			}
			
			$var += $points;
			$total += $points;
			
			if(count($rows)){
				$sql = "update `#__karma_tb` set `var_karma` = '$var', `total_karma` = '$total' where `user_id` = '$my->id'";
			} else {
				$sql = "insert into `#__karma_tb` values ('$my->id', '$var', '$total')";
			}
			$database->setQuery($sql);
			$database->query();
			
			//log points
			logPoints($my->id, $points, "Created a forum thread");
		}
	} else if($option == "com_content" && $task == "save"){
		if ($my->gid < 1) {
			return 0;
		}

		$id = mosGetParam($_POST, 'id', 0);
		
		if(!$id){
			$points = getConfPoints("content");
			
			$rows = getUser($my->id);
			
			$var = 0;
			$total = 0;
			if(count($rows)){
				$row=$rows[0];
				
				$var += $row->var_karma;
				$total += $row->total_karma;
			}
			
			$var += $points;
			$total += $points;
			
			if(count($rows)){
				$sql = "update `#__karma_tb` set `var_karma` = '$var', `total_karma` = '$total' where `user_id` = '$my->id'";
			} else {
				$sql = "insert into `#__karma_tb` values ('$my->id', '$var', '$total')";
			}
			
			$database->setQuery($sql);
			$database->query();
			
			//log points
			logPoints($my->id, $points, "Submitted a content");
		}
	} else if($option == "com_comprofiler" && $task == "saveUserEdit"){
		if ($my->gid < 1) {
			return 0;
		}
		
		$points = getConfPoints("cb_profile");
			
		$rows = getUser($my->id);
		
			$var = 0;
			$total = 0;
			if(count($rows)){
				$row=$rows[0];
				
				$var += $row->var_karma;
				$total += $row->total_karma;
			}
			
			$var += $points;
			$total += $points;
			
			if(count($rows)){
				$sql = "update `#__karma_tb` set `var_karma` = '$var', `total_karma` = '$total' where `user_id` = '$my->id'";
			} else {
				$sql = "insert into `#__karma_tb` values ('$my->id', '$var', '$total')";
			}
			
			$database->setQuery($sql);
			$database->query();
			
			//log points
			logPoints($my->id, $points, "Updated user profile");
	}
}

function getConfPoints($name){
	global $database;
	
	$sql = "select value from `#__karma_conf` where name = '$name' limit 1";
	$database->setQuery($sql);

	return intval($database->loadResult());
}

function getUser($id){
	global $database;
	
	$sql = "select * from `#__karma_tb` where `user_id` = '$id' limit 1";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	return $rows;
}

function logPoints($user, $points, $description){
	global $database;
	$currentDate = mosCurrentDate("%Y-%m-%d %H:%M:%S");

	$sql = "insert into `#__karma_points_log` values ('$user', '$points', '$description', '$currentDate')";
	$database->setQuery($sql);
	$database->query();
}
?>
