<?php
/**
* @version 1.0.1
* @package Blank
* @copyright (C) 2006 www.galangph.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

require_once( $mainframe->getPath('class') );

class myPat{
	function &createTemplate() {
		global $option, $mosConfig_absolute_path;
		
		require_once( $mosConfig_absolute_path . '/includes/patTemplate/patTemplate.php' );
 
		$tmpl =& patFactory::createTemplate( $option, true, false );
		$tmpl->setRoot( dirname( __FILE__ ) . '/tmpl' );
 
		return $tmpl;
	}
}

class ADMIN_html{
	function showConfig($obj, $option){
		$tmpl =& myPat::createTemplate();
		$tmpl->setAttribute('body', 'src', 'admin.html');
		$tmpl->loadTemplate('body');
		
		$tmpl->addVar('config', 'IPPROTECT', mosHTML::yesnoRadioList('ipprotect', 'class="inputbox"', CLASS_karma::getConfig('ipprotect')));
		$tmpl->addVar('config', 'DAYLOCK', CLASS_karma::getConfig('daylock'));
		$tmpl->addVar('config', 'REVIEW', CLASS_karma::getConfig('review'));
		$tmpl->addVar('config', 'REGISTER', CLASS_karma::getConfig('review'));
		$tmpl->addVar('config', 'CONTENT', CLASS_karma::getConfig('content'));
		$tmpl->addVar('config', 'LINK', CLASS_karma::getConfig('link'));
		$tmpl->addVar('config', 'FORUM', CLASS_karma::getConfig('forum'));
		
		$tmpl->addVar('config', 'CBPROFILE', CLASS_karma::getConfig('cb_profile'));

		$tmpl->addVar('config', 'CUSTOM1', CLASS_karma::getConfig('custom1'));
		$tmpl->addVar('config', 'CUSTOM2', CLASS_karma::getConfig('custom2'));
		$tmpl->addVar('config', 'CUSTOM3', CLASS_karma::getConfig('custom3'));
		$tmpl->addVar('config', 'OPTION', $option);
		
		$tmpl->setAttribute('config', 'visibility', 'visible');
	
		$tmpl->displayParsedTemplate('form');
	}

	function showManagement($rows, $pageNav, $option){
		$tmpl =& myPat::createTemplate();
		$tmpl->setAttribute('body', 'src', 'admin.html');
		$tmpl->loadTemplate('body');
		
		for($i=0, $n=count($rows);$i<$n;$i++){
			$row=$rows[$i];
			$tmpl->addVar('userrow', 'CB', mosHTML::idBox($i, $row->id));
			$tmpl->addVar('userrow', 'ID', $row->id);
			$tmpl->addVar('userrow', 'ROWNUM', ($i+1));
			$tmpl->addVar('userrow', 'NAME', $row->name);
			$tmpl->addVar('userrow', 'USERNAME', $row->username);
			$tmpl->addVar('userrow', 'EMAIL', $row->email);
			$tmpl->addVar('userrow', 'MONTHLY', intval($row->var_karma));
			$tmpl->addVar('userrow', 'TOTAL', intval($row->total_karma));
			
			$tmpl->parseTemplate('userrow', 'a');
		}
		
		$tmpl->addVar('management', 'LISTFOOTER', $pageNav->getListFooter());
		$tmpl->addVar('management', 'OPTION', $option);
		$tmpl->addVar('management', 'ROWCOUNT', count($rows));
		$tmpl->setAttribute('management', 'visibility', 'visible');
		$tmpl->displayParsedTemplate('form');
	}
	
	function edit($kObj, $userObj, $option){
		$tmpl =& myPat::createTemplate();
		$tmpl->setAttribute('body', 'src', 'admin.html');
		$tmpl->loadTemplate('body');
		
		$tmpl->addVar('editform', 'NAME', $userObj->name);
		$tmpl->addVar('editform', 'USERNAME', $userObj->username);
		$tmpl->addVar('editform', 'USERID', $userObj->id);
		$tmpl->addVar('editform', 'MONTHLY', intval($kObj->var_karma));
		$tmpl->addVar('editform', 'TOTAL', intval($kObj->total_karma));
		
		$tmpl->setAttribute('editform', 'visibility', 'visible');
		$tmpl->displayParsedTemplate('form');
	}
	
	function showUserLogs($rows, $userObj, $pageNav, $orderHTML, $option){
		$tmpl =& myPat::createTemplate();
		$tmpl->setAttribute('body', 'src', 'admin.html');
		$tmpl->loadTemplate('body');
		
		$tmpl->addVar('userlogs', 'NAME', $userObj->name);
		$tmpl->addVar('userlogs', 'USERNAME', $userObj->username);
		$tmpl->addVar('userlogs', 'ORDERSELECT', $orderHTML);
		
		for($i=0, $n=count($rows);$i<$n;$i++){
			$row=$rows[$i];
			$tmpl->addVar('logrows', 'NUM', $i+$pageNav->limitstart+1);
			$tmpl->addVar('logrows', 'USERID', $row->user_id);
			$tmpl->addVar('logrows', 'POINTS', $row->points);
			$tmpl->addVar('logrows', 'DESCRIPTION', $row->description);
			$tmpl->addVar('logrows', 'TIMESTAMP', $row->timestamp);
			
			$tmpl->parseTemplate('logrows', 'a');
		}
		
		$tmpl->addVar('userlogs', 'LISTFOOTER', $pageNav->getlistfooter());
		$tmpl->addVar('userlogs', 'OPTION', $option);
		$tmpl->addVar('userlogs', 'ID', $userObj->id);
		$tmpl->setAttribute('userlogs', 'visibility', 'visible');
		$tmpl->displayParsedTemplate('form');
	}
}

?>
