<?php
/**
* @version 1.0.1
* @package Blank
* @copyright (C) 2006 www.galangph.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

require_once( $mainframe->getPath('class') );
require_once( $mainframe->getPath('admin_html') );

$option = mosGetParam($_REQUEST, 'option', '');
$task 	= mosGetParam($_REQUEST, 'task', '');
$act 	= mosGetParam($_REQUEST, 'act', '');

switch($task){
case "config":
	showConfig($option);
	break;
case "management":
	showManagement($option);
	break;
	
case "save":
	save($option);
	mosRedirect("index2.php?option=$option&task=config", "Saved");
	break;
case "cancel":
	mosRedirect('index2.php', 'Cancelled');
	break;
case "edit":
	edit($option);
	break;
case "saveedited":
	saveedited($option);
break;
case "resettotal":
	resetTotal($option);
	break;
case "resetmonthly":
	resetMonthly($option);
	break;
case "resetalltotal":
	resetAllTotal($option);
	break;
case "resetallmonthly":
	resetAllMonthly($option);
	break;
case "showlog":
	showLog($option);
	break;
}

function showConfig($option){
	$configObj = new stdclass;
	$configObj->ipprotect = CLASS_karma::getConfig('ipprotect');
	$configObj->daylock = CLASS_karma::getConfig('daylock');
	
	ADMIN_html::showConfig($configObj, $option);
}

function save($option){
	global $database;
	
	//$ipprotect = intval(mosGetParam($_POST, 'ipprotect', ''));
	$daylock = intval(mosGetParam($_POST, 'daylock', ''));
		
	//CLASS_karma::setConfig('ipprotect', $ipprotect);
	CLASS_karma::setConfig('daylock', $daylock);
	
	//points
	$review = intval(mosGetParam($_POST, 'review', 0));
	$register = intval(mosGetParam($_POST, 'register', 0));
	$content = intval(mosGetParam($_POST, 'content', 0));
	$link = intval(mosGetParam($_POST, 'link', 0));
	$forum = intval(mosGetParam($_POST, 'forum', 0));

	$cb_profile = intval(mosGetParam($_POST, 'cb_profile', 0));
	
	$custom1 = intval(mosGetParam($_POST, 'custom1', 0));
	$custom2 = intval(mosGetParam($_POST, 'custom2', 0));
	$custom3 = intval(mosGetParam($_POST, 'custom3', 0));
	
	CLASS_karma::setConfig('review', $review);
	CLASS_karma::setConfig('register', $register);
	CLASS_karma::setConfig('content', $content);
	CLASS_karma::setConfig('link', $link);
	CLASS_karma::setConfig('forum', $forum);
	CLASS_karma::setConfig('cb_profile', $cb_profile);
	CLASS_karma::setConfig('custom1', $custom1);
	CLASS_karma::setConfig('custom2', $custom2);
	CLASS_karma::setConfig('custom3', $custom3);
}

function showManagement($option){
	global $database, $mosConfig_absolute_path, $mosConfig_list_limit, $mainframe;
	
	$limit 	= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );

	$sql = "select count(id) from `#__users` where 1 \n";
	$database->setQuery($sql);
	$total = $database->loadResult();

	require_once( $mosConfig_absolute_path . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	
	$sql = "select a.id, a.name, a.username, a.email, b.var_karma, b.total_karma \n" .
		"from `#__users` as a LEFT JOIN `#__karma_tb` as b \n" .
		"on a.id = b.user_id \n" .
		"order by a.id ASC \n".
		"limit $pageNav->limitstart, $pageNav->limit \n";
	
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	ADMIN_html::showManagement($rows, $pageNav, $option);
}

function edit($option){
	global $database;
	
	$user = intval(mosGetParam($_GET, 'user', ''));

	$karmaTb = new CLASS_karmaTb($database);
	
	$karmaTb->load($user);

	$userObj = new mosUser($database);
	$userObj->load($user);
	
	ADMIN_html::edit($karmaTb, $userObj, $option);
}

function saveedited($option){	
	global $database;
	
	$obj = new stdclass;
	$obj->user_id = mosGetParam($_POST, 'user_id', '');
	$obj->var_karma = mosGetParam($_POST, 'var_karma', '');
	$obj->total_karma = mosGetParam($_POST, 'total_karma', '');

	$sql = "select count(user_id) from `#__karma_tb` where `user_id` = '$obj->user_id' \n";
	$database->setQuery($sql);
	$count = $database->loadResult();

	if($count){
		$database->updateObject("#__karma_tb", $obj, "user_id");
	} else {
		$database->insertObject("#__karma_tb", $obj);
	}
	
	mosRedirect("index2.php?option=$option&task=management", "Edited");
}

function resetTotal($option){
	global $database;

	$cid = mosGetParam($_POST, 'cid', array(0));
	$cids = implode(',', $cid);
	
	$sql = "update `#__karma_tb` set `total_karma` = '0' where `user_id` in ($cids)";
	$database->setQuery($sql);
	
	if($database->query()){
		$msg = "Reset Successful";
	} else {
		$msg = "Error: Database Query";
	}
	
	mosRedirect("index2.php?option=$option&task=management", $msg);
}

function resetMonthly($option){
	global $database;
	
	$cid = mosGetParam($_POST, 'cid', array(0));
	$cids = implode(',', $cid);
	
	$sql = "update `#__karma_tb` set `var_karma` = '0' where `user_id` in ($cids)";
	$database->setQuery($sql);

	
	if($database->query()){
		//clear logs
		$sql = "delete from `#__karma_log` where `user_id` in ($cids)";
		$database->setQuery($sql);
		$database->query();

		$msg = "Reset Successful";
	} else {
		$msg = "Error: Database Query";
	}
	
	mosRedirect("index2.php?option=$option&task=management", $msg);
}

function resetAllMonthly($option){
	global $database;
	
	$sql = "update `#__karma_tb` set `var_karma` = '0' where 1";
	$database->setQuery($sql);
	
	if($database->query()){
		//clear logs
		$sql = "delete from `#__karma_log` where 1";
		$database->setQuery($sql);
		$database->query();
	
		$msg = "Reset Successful";		
	} else {
		$msg = "Error: Database Query";
	}
	
	mosRedirect("index2.php?option=$option&task=management", $msg);
}

function resetAllTotal($option){
	global $database;
	
	$sql = "update `#__karma_tb` set `total_karma` = '0' where 1";
	$database->setQuery($sql);
	
	if($database->query()){
		mosRedirect("index2.php?option=$option&task=management", "Reset Succesful");
	} else {
		mosRedirect("index2.php?option=$option&task=management", "Error: Database Query");
	}
}

function showLog($option){
	global $database, $mosConfig_absolute_path, $mosConfig_list_limit, $mainframe;
	
	$user = mosGetParam($_REQUEST, 'user', 0);
	$limit 	= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
	$order = mosGetParam($_REQUEST, 'order', 'DESC');

	if(!$user){
		mosRedirect("index2.php?option=$option&task=management", "Invalid user");
	}

	$sql = "select count(user_id) from `#__karma_points_log` where `user_id` = '$user'";
	$database->setQuery($sql);
	$total = $database->loadResult();

	require_once( $mosConfig_absolute_path . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );	
	
	$sql = "select * from `#__karma_points_log` \n".
		"where `user_id` = '$user' \n".
		"order by `timestamp` $order \n".
		"limit $pageNav->limitstart, $pageNav->limit \n";
	$database->setQuery($sql);
	$rows = $database->LoadObjectList();
	
	//get user object
	$sql = "select `id`, `name`, `username` from `#__users` where `id` = '$user'";
	$database->setQuery($sql);
	$userObj = $database->loadObjectList();
	$userObj=$userObj[0];
	
	$ordering = array();
	$ordering[] = mosHTML::makeOption('ASC', 'Ascending');
	$ordering[] = mosHTML::makeOption('DESC', 'Descending');
	$orderHTML = mosHTML::selectList($ordering, 'order', 'size="1" class="inputbox" onchange="this.form.submit()"', 'value', 'text', $order);
	
	ADMIN_html::showUserLogs($rows, $userObj, $pageNav, $orderHTML, $option);
}
?>
