<?php
/**
* @version 1.0.1
* @package Blank
* @copyright (C) 2006 www.galangph.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

class CLASS_karma{
	function getConfig($name = ''){
		global $database;
		
		if($name != ''){
			$sql = "select `value` from `#__karma_conf` where `name` = '$name' limit 1";
			$database->setQuery($sql);
			return $database->loadResult();
		}
		return false;
	}
	
	function setConfig($name = '', $value = ''){
		global $database;
		
		if($name != ''){
			$sql = "update `#__karma_conf` set `value` = '$value' where `name` = '$name'";
			$database->setQuery($sql);
			return $database->query();
		}
		return false;
	}
	
	function addPoints($user, $value = 0, $description = ""){
		global $database;
		$currentDate = mosCurrentDate("%Y-%m-%d %H:%M:%S");

		$sql = "select * from `#__karma_tb` where `user_id` = '$user' limit 1";
		$database->setQuery($sql);
		$rows = $database->loadObjectList();
		
		if(count($rows)){
			$row=$rows[0];
			$var = $row->var_karma + $value;
			$total = $row->total_karma + $value;
			
			$sql = "update `#__karma_tb` set `var_karma` = '$var', `total_karma` = '$total' where `user_id` = '$user'";
		} else {
			$sql = "insert into `#__karma_tb` values ('$user', '$value', '$value')";
		}
		
		$database->setQuery($sql);
		$status = $database->query();
		
		if($status){
			$sql = "insert into `#__karma_points_log` values ('$user', '$value', '$description', '$currentDate')";
			$database->setQuery($sql);
			$status = $database->query();
		}
	}

	function remPoints($user, $value = 0, $description = ""){
		global $database;
		$currentDate = mosCurrentDate("%Y-%m-%d %H:%M:%S");

		$sql = "select * from `#__karma_tb` where `user_id` = '$user' limit 1";
		$database->setQuery($sql);
		$rows = $database->loadObjectList();
		
		if(count($rows)){
			$row=$rows[0];
			$var = $row->var_karma - $value;
			$total = $row->total_karma - $value;
			
			$sql = "update `#__karma_tb` set `var_karma` = '$var', `total_karma` = '$total' where `user_id` = '$user'";
		} else {
			$sql = "insert into `#__karma_tb` values ('$user', '$value', '$value')";
		}
		
		$database->setQuery($sql);
		$status = $database->query();
		
		if($status){
			$sql = "insert into `#__karma_points_log` values ('$user', '-$value', '$description', '$currentDate')";
			$database->setQuery($sql);
			$status = $database->query();
		}
	}
}

class CLASS_karmaTb extends mosDbTable{
	
	/* @var int */
	var $user_id = NULL;
	
	/* @var int */
	var $var_karma = NULL;
	
	/* @var int */
	var $total_karma = NULL;
	
	function CLASS_karmaTb(&$database){
		if(!$this->mosDbTable("#__karma_tb", "user_id", $database))
			return false;
		return true;
	}
}

class CLASS_karmaLog extends mosDbTable{
	/* @var int primary key */
	var $id = NULL;
	
	/* @var int */
	var $user_id = NULL;
	
	/* @var int */
	var $my_id = NULL;
	
	/* @var int */
	var $type = NULL;
	
	/* @var string */
	var $timestamp = NULL;
	
	/* @var string */
	var $ip  = NULL;
	
	function CLASS_karmaLog(&$database){
		$this->mosDbTable('#__karma_log', 'id', $database); 
	}
}

?>
